#! /usr/bin/env python

import subprocess, os, sys, math, argparse, platform

baseDir = os.getcwd()
srcDir = os.path.join(baseDir, 'src')

if platform.system() == "Windows":
    generator = "Ninja"
    compileCmd = "ninja"
elif platform.system() == "Linux":
    generator = "Unix Makefiles"
    compileCmd = ["make", "install"]

parser = argparse.ArgumentParser()
parser.add_argument('-version', default='Release', choices=['Debug', 'Release'])
args = parser.parse_args()


buildDir = os.path.join(baseDir, 'build', args.version)

if not os.path.exists(buildDir):
    os.makedirs(buildDir)

configCmd = ["cmake", "-G" + generator, '-DCMAKE_INSTALL_PREFIX=' + baseDir,
              '-DCMAKE_BUILD_TYPE=' + args.version, "-S", srcDir, "-B", buildDir]
subprocess.call(configCmd)

subprocess.call(compileCmd, cwd = buildDir)
