#! /usr/bin/env python
# -*- coding: utf-8 -*-

import time

try:
    unicode('')
except NameError:
    unicode = str

acc_in = '''
#SBATCH --partition=cpu_dist
#SBATCH --reservation=ams301_csp
#SBATCH --account=ams301
'''

acc_out = '''
#SBATCH --partition=cpu_test
##SBATCH --reservation=ams301_csp
#SBATCH --account=ams301
'''

# annee, mois, jour, debut(heure.minute), fin(heure.minute)
courses = [
  [2022, 11, 25,  9.0, 12.16],
  [2022, 12,  2,  9.0, 12.16],
  [2022, 12,  9,  9.0, 12.16],
  [2022, 12, 16,  9.0, 12.16],
  [2023,  1,  6,  9.0, 12.16],
  [2023,  1, 13,  9.0, 12.16],
  [2023,  1, 20,  9.0, 12.16],
  [2023,  1, 27,  9.0, 12.16],
  [2023,  2,  3,  9.0, 12.16],
  [2023,  2, 10,  9.0, 12.16]
]


def queue():
  t = time.localtime()
  hm = t.tm_hour + 0.01 * t.tm_min
  
  inCourse = False
  for tc in courses:
    if t.tm_year == tc[0] and t.tm_mon == tc[1] and t.tm_mday == tc[2]:
      
      if hm > tc[3] and hm < tc[4]:
        inCourse = True
        break

  if inCourse:
     return acc_in
  else:
     return acc_out

class Range(object):
    def __init__(self, start, end = None):
        self.start = start
        self.end = end

    def __eq__(self, other):
        if self.end:
            return self.start <= other <= self.end
        else:
            return self.start <= other

    def __contains__(self, item):
        return self.__eq__(item)

    def __iter__(self):
        yield self

    def __str__(self):
        if self.end:
            return 'in ]{0},{1}]'.format(self.start, self.end)
        else:
            return '> {0}'.format(self.start)

def argList(args):
    l = []
    for a in args:
        l += ["--" + a, str(args[a])]
    return l

